/*

  TRAVDIRS traverses through all directories on the current disk,
  executing a specified command.

*/


#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <dir.h>
#include <dos.h>
#include <string.h>


#define MAXCOMLINE 128

char dos_command [MAXCOMLINE];
char initial_directory [MAXCOMLINE];

void traverse_directories (void);

void main (int argc, char *argv [])
{
   puts ("TRAVDIRS version 1.0 by Ilya Shlyakhter   (617) 232-3703  Last updated 12-28-90\n");

   if (argc  < 2) {
         puts ("TRAVDIRS traverses through all subdirectories on the current disk, executing ");
         puts ("a specified command.");
         puts ("\nSyntax: TRAVDIRS dos-command");
         puts ("\nExamples:");
         puts ("TRAVDIRS DIR");
         puts ("TRAVDIRS \"DEL *.BAK\"");
         puts ("TRAVDIRS cd");
         putchar ('\n');
         exit (1);
      }
         else  {
               strcpy (dos_command,argv [1]);
               getcwd (initial_directory,MAXCOMLINE);
               traverse_directories ();
               chdir (initial_directory);
            }

   exit (0);
}

void traverse_directories (void)
{
   struct ffblk myfile;

   if (system (dos_command))  {
         printf ("\nError executing \"%s\"",dos_command);
      }


   if (! findfirst ("*.*",&myfile,FA_DIREC))  {
       while (! findnext (&myfile))  {
            if ((myfile.ff_attrib & FA_DIREC) && strcmp (myfile.ff_name,".") && strcmp (myfile.ff_name,"..")) {
                  chdir (myfile.ff_name);
                  traverse_directories ();
                  chdir ("..");
               }
          }

      }
}






